/****************************************************************************
** Leistungsorientierte Krankenanstaltenfinanzierung (LKF)                 **
** Scoring-C-Sourcen V2021.0                                               **
** (C) 2020 BMSGPK                                                         **
*****************************************************************************
** lkf5test.h - Schnittstellendefinitionen                                 **
**                                                                         **
**		 Alex.Holzer@chello.at                                             **
**       Bernhard.Pesec@dothealth.at                                       **
***************************************************************************/

#ifndef LKF5TEST_H
#define LKF5TEST_H

#define BUFFER_LEN 32000

typedef struct LKF_TESTCONTEXT {
    
    const char stammPath[1024];
    
    unsigned int error_alloc;
    unsigned int error_count;
    char **bufferPointer;
    
    unsigned int buffer_count;
    unsigned int current_buffer_alloc;
    unsigned int current_buffer_offset;
    char **buffer;
} LKF_TESTCONTEXT;

_SCORING_EXPORT LKF_TESTCONTEXT *lkf_alloc_testcontext(const char *stammPath);
_SCORING_EXPORT void lkf_free_testcontext(LKF_TESTCONTEXT *pContext);
_SCORING_EXPORT unsigned int lkf_test_utils (LKF_TESTCONTEXT *testContext);
_SCORING_EXPORT unsigned int lkf_test_aufenthalt1 (LKF_TESTCONTEXT *testContext);


_SCORING_EXPORT unsigned int lkf_test_getIssueCount (LKF_TESTCONTEXT *testContext);
_SCORING_EXPORT const char *lkf_test_getIssue (LKF_TESTCONTEXT *testContext, unsigned int i);

#endif  /* LKF5TEST_H */
