//
//  LKFAufenthaltError.swift
//  lkfc
//
//  Created by Alexander Holzer on 21.08.18.
//  Copyright © 2018 Alexander Holzer. All rights reserved.
//

import Foundation
@_implementationOnly import LibLKF

public class LKFAufenthaltError {
    
    let code : String
    let text : String
    let value : String
    
    init (aufenthalt: LKFAufenthalt, error: OpaquePointer!) {
        let ptr = UnsafeMutablePointer<CChar>.allocate(capacity: 256)
        let contextPtr = aufenthalt.context!.ptr
        LibLKF.lkf_satzart_getValue (contextPtr, error, 102, ptr, 256)
        code = String(cString:ptr)
        LibLKF.lkf_satzart_getValue (contextPtr, error, 105, ptr, 256)
        text = String(cString:ptr)
        LibLKF.lkf_satzart_getValue (contextPtr, error, 109, ptr, 256)
        value = String(cString:ptr)
        ptr.deallocate()
    }
    
    public static func getErrors (aufenthalt: LKFAufenthalt) -> [LKFAufenthaltError]? {
        
        var errorPtr = LibLKF.lkf_auf_getSatzartError(aufenthalt.ptr)
        
        if errorPtr == nil {
            return nil
        }

        var errors = [LKFAufenthaltError]()
        
        while errorPtr != nil {
            errors.append(LKFAufenthaltError(aufenthalt: aufenthalt, error: errorPtr!))
            errorPtr = LibLKF.lkf_auf_getNextSatzartError(errorPtr)
        }
        
        return errors
    }
}
