// Dies ist die Haupt-DLL.
#include "Stdafx.h"

#pragma once
#include "lkfxdok.h"


extern "C" {
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "lkf5defs.h"
}

using namespace System::Runtime::InteropServices;

#include "LKFController.h"
#include "LKFDataProvider.h"


namespace lkfxdok {
	namespace c {
		String ^LKFController::Version::get(void) {
			const char *v = lkf_GetVersion();
			return gcnew String(v);
		}

		String ^LKFController::DataPath::get (void) {
			if (_path != nullptr)
				return _path;
			return "NULL";
		}
			
		void LKFController::DataPath::set(String ^path) {
			_path = path;
		}

		unsigned int LKFController::ModelljahrMinimum::get(void) {
			return lkf_GetYearFirst();
		}

		unsigned int LKFController::ModelljahrMaximum::get(void) {
			return lkf_GetYearLatest();
		}

		void LKFController::debugmemory_mark(String ^marker) {
			char *cline = (char*)(Marshal::StringToHGlobalAnsi(marker)).ToPointer();
			lkf_debugmemory_write_marker(cline);
			Marshal::FreeHGlobal((IntPtr)cline);
		}

		void LKFController::debugmemory_confirm_open_blocks(void) {
			lkf_debugmemory_confirm_open_blocks();
		}

		void LKFController::debugmemory_report_open_blocks(void) {
			lkf_debugmemory_report_open_blocks();
		}

		void LKFController::debugmemory_close(void) {
			lkf_debugmemory_close();
		}

		LKFDataProvider ^LKFController::DataProvider::get() {
			return _dataProvider;
		}

		void LKFController::DataProvider::set(LKFDataProvider ^provider) {
			if (_dataProvider != nullptr) {
				_dataProvider->Deassign();
			}
			_dataProvider = provider;
			if (_dataProvider != nullptr) {
				_dataProvider->Assign();
			}
		}
	}
}
